-module(fifo).
-export([new/0, push/2, pop/1, empty/1]).

%% implemented as two stacks; push on the first, pop on the second.
%% when the second is empty, reverse the first and make it the second.
new() -> 
    {fifo, [], []}.

push(X,{fifo, In, Out}) -> 
    {fifo, [X|In], Out}.

pop({fifo, [], []}) -> 
    erlang:error('empty fifo');
pop({fifo, In, []}) -> 
    pop({fifo, [], lists:reverse(In)});
pop({fifo, In, [H|T]}) -> 
    {H, {fifo, In, T}}.

empty({fifo, [], []}) -> true;
empty({fifo, _, _}) -> false.

% F1 = fifo:new().
% F2 = fifo:push(a,F1).
% F3 = fifo:push(b,F2).
% F4 = fifo:push(c,F3).
% {V,F5} = fifo:pop(F4).
% V.
% F5.
% fifo:empty(F5).