-module(pingpong).

-export([start/1, ping/1, pong/0]).

start(N) ->
    % register(Name,Pid).
    %     Associates the atom Name with the process Pid.
    %     hides real id
    register(pong, spawn(pingpong, pong, [])),
    spawn(pingpong, ping, [N]).

ping(0) ->
    io:format("Ping!~n", []),
    pong ! stop;
ping(N) ->
    io:format("[~p] Ping...~n", [N]),
    pong ! {ping, self()},
    receive
        pong -> ping(N - 1)
    end.

pong() ->
    receive
        stop ->
            io:format("Pong!~n", []);
        {ping, Ping_PID} ->
            io:format("Pong...~n", []),
            Ping_PID ! pong,
            pong()
    end.

% pingpong:start(5).

% unregister(Name)
%     Removes the association

% whereis(Name)
%     Returns the pid associated with the registered name Name.
%     or it returns the atom undefined.

% registered()
%     Returns a list of all the currently registered names.